//
// Hilfsprogramme fr die Funkfernsteuerung von Steckdosen
//
#include <avr/io.h>  

//.extern VAr;

//
// Das Ausgabesignal wird an Pin 4 des Port B geliefert (PB4)
//
// Die Pulsdauer ist fr eine Taktfrequenz von 14,7456 MHz ausgelegt
//


// ***** Telegramm zur Sendermodulation erzeugen *****
//	Das Programm gibt an einem Portpin ein HX2262 kompatibles Datentelegramm aus
//	Parameter 1 wird in r24:r25 bergeben und enthlt den Zeiger auf das Datenfeld
//	Die Anzahl der Telegrammwiderholungen wird aus VAr gelesen
//	Es wird nichts zurckgegeben.
//	r2-r17, r28-r29 mssen gerettet werden!
//
//
.global sendeTelegramm
.func sendeTelegramm

sendeTelegramm:
	ldi		r22, 6		// Anzahl der TelegrammWiederholungen aus VAr lesen , vorher: lds r22,VAr
		
	Anzahlschleife:			// Schleife ber die Telegrammanzahl, Zwei Telegramme sind mindestens erforderlich
		movw	r30, r24		// Adresse des Datenfeldes nach Z laden
		ldi		r23, 3			// drei Daten-Byte = 12 Telegrammbits bearbeiten
		mov		r1, r23			// r1 zhlt die Datenbytes
		
		Byteschleife:				// Schleife ber die drei Datenbytes
			ld		r21, Z+				// Byte einlesen
			rcall	Bytebearbeitung		// Byte bearbeiten
			dec		r1					// Bytezhler decrementieren
		brne Byteschleife			// zurck zum Schleifenanfang bis 0 erreicht ist
		
		ldi		r23, 1			// Synchronimpuls ausgeben, nur ein Halbbit 
		eor		r21, r21		// r21 lschen, das Halbbit soll eine '0' sein
		rcall	synceinstieg	// und Halbbit ausgeben
		ldi		r21,7			// sieben weitere Halbbits Pause = 28 Zyklen
		mov		r1, r21			// r1 zhlt die Halbbits
		eor		r21, r21		// r21 lschen
		
		Syncpausenschleife:
			ldi		r23, 1			// ein Halbbit als Pause ausgeben
			rcall	pauseneinstieg
			dec		r1				// Zhler decrementieren
		brne	Syncpausenschleife	// zum Schleifenanfang bis 0 erreicht ist
		
		dec		r22				// Telegrammwiederholungszhler decrementieren
	brne Anzahlschleife		// zurck zum Schleifenanfang bis 0 erreicht ist
ret

	Bytebearbeitung:
		ldi		r23, 8			// acht Bit pro Byte bearbeiten (jedes Bit ist ein Halbbit des Telegramms)
		Bitschleife:			// Schleife ber die acht Bit des zu bearbeitenden Bytes
				
			synceinstieg:							// Seiteneinstieg, wenn nur der Synchronimpuls ausgegeben werden soll
				sbi		_SFR_IO_ADDR(PORTB), PB4	// Datenleitung B 4 auf 1 setzen
				
			pauseneinstieg:							// Seiteneinstieg, wenn nur die Wartetakte gebraucht werden
				rcall	einenTaktwarten
				lsl		r21							// Datenbit nach CY schieben 
			brcs	eins
				
				cbi		_SFR_IO_ADDR(PORTB), PB4	// bei Carry=0 Datenleitung auf 0 setzen ("0" bearbeiten)
				
			eins: 
				rcall	einenTaktwarten
				rcall	einenTaktwarten
				cbi		_SFR_IO_ADDR(PORTB), PB4	// Datenltg. auf 0 setzen ("1" bearbeiten, schadet aber nicht bei "0")
				rcall	einenTaktwarten
				
			dec		r23					// Bitzhler decrementieren
		brne Bitschleife		// zurck zum Schleifenanfang bis 0 erreicht ist
	ret

		einenTaktwarten:			// 370 s Warteschleife
			ldi	r27,	1015/256	// 14 Zyklen/MHz * 370 = 5180; 5180/4 = 1295;  Werte auf 11 Mhz angepasst
			ldi	r26,	1015%256	// 1295 - 2 fr call/ret u.a.   Werte auf 11 Mhz angepasst
			lp:
				sbiw	r26, 1			// 2 Zyklen
			brne lp						// 2 (bzw. 1)
		ret

.endfunc
.end
