/*#######################################################################################
AVR Small Webserver 
Copyright (C) 2004 Ulrich Radig
Copyright (C) 2005 Joachim Brke

In dieser Datei wird der GET-request bearbeitet

#######################################################################################*/

#include "main.h"
#include <webpage.h> 
#include "OWI/OWIPolled.h"
#include "OWI/OWIcrc.h"

//#######################################################################################
// *param		Name des zu suchenden Parameters (=HTML-Formularelement)
// *buffer		Anfang des Seitenbuffers
// bufferlen	Lnge des Buffers
// datum		Variable mit dem Datum das eingegeben werden soll
//
// Rckgabewert: Das Datum, das mit dem Formularelement eingegeben wurde
//
int searchParameter(unsigned char * param, unsigned char * buffer, unsigned char bufferlen, int datum) 
//#######################################################################################
{ 
	unsigned int len = strlen(param); 
	unsigned int i; 
	unsigned char * j;
	for(i=0;i<bufferlen-len-1;i++)	// Anfang des Parameters suchen
	{ 
		if(memcmp(buffer+i,param,len)==0 		// wenn der Parameter gefunden wurde
			&& buffer[i+len]=='=' 					// und am Ende ein =
			&& (buffer[i-1]=='?'					// und davor ein ?
			||buffer[i-1]=='&'						//   oder ein &
			||buffer[i-1]==0))					//   oder eine 0 stehen, dann ...
		{ 
			i += len+1; 				// Anfang des Parameterwertes = Anfangparametername + Lnge + 1
			j = buffer+i;				// j zeigt auf das erste Zeichen des Parameterwertes
			while(*j != 0 && *j != '&' && *j != ' ')  j++;	//Ende des Parameterwertes suchen
			*j=0;						// 0 hinter den Parameterwert schreiben und String abschlieen
			datum = atoi(buffer+i);	// String in eine Intergerzahl umwandeln
			return(datum);				// neuen Parameterwert zurckgegeben
	 	} 
	}
	return(datum); 				// mindestens den alten Parameterwert zurckgegeben (=erhalten)
}

//#######################################################################################
// *param		Name des zu suchenden Parameters (=HTML-Formularelement)
// *buffer		Anfang des Seitenbuffers
// bufferlen	Lnge des Buffers
// Globale Variablen: 
// Index		indiziert den Datensatz im EEPROM
// Rckgabewert: keiner
// indirekt:	Der Name, der mit dem Formularelement eingegeben wurde, wird im EEPROM in
//				dem Datensatz "Index" abgelegt.
//
void searchName(unsigned char * param, unsigned char * buffer, unsigned char bufferlen) 
//#######################################################################################
{ 
	unsigned int len = strlen(param); 
	unsigned int i; 
	char k, l;
	unsigned char * j;
	for(i=0;i<bufferlen-len-1;i++) // Anfang des Parameters suchen
	{ 
		if(memcmp(buffer+i,param,len)==0 		// wenn der Parameter gefunden wurde
			&& buffer[i+len]=='=' 					// und am Ende ein =
			&& (buffer[i-1]=='?'					// und davor ein ?
			  ||buffer[i-1]=='&'					//   oder ein &
			  ||buffer[i-1]==0))					//   oder eine 0 stehen, dann ...
		{ 
			i += len+1; 			// Anfang des Parameterwertes = Anfangparametername + Lnge + 1
			j = buffer+i;			// j zeigt auf das erste Zeichen des Parameterwertes
			for (k=8;k<16;k++) {	// wir haben im EEPROM 8 Stellen zur Verfgung
				if (*j != 0 && *j != '&' && *j != ' ') { // solange wir nicht am Ende des Parameterwertes sind
					if (*j=='+') l = ' ';	// Leerzeichen vom Browser empfangen
					else if (*j=='*') {	// es liegt ein Token vor
						j++;				// nchstes Zeichen adressieren
						l = *j;			// und bearbeiten
						l -= (l>'9') ? 'A'-10 : '0';	// das Zeichen ist der Index des Tokens
					}
					else l = *j; 			// kein Token sondern druckbares Zeichen
					j++;					// Zeiger auf nchstes Zeichen
				}
				else l = 0xff;				// nicht benutzte Stellen mit "FF" auffllen
				eeprom_write_byte((char *)(Index<<4)+k,l); // Stelle im EEPROM ablegen
			}
	 	} 
	}
}

//#######################################################################################
void httpd (char* buffer,int *bufferlen)
//#######################################################################################
{

char A_EIN[] = {0x10,0x05,0x51};	// Steckdose a ein
char A_AUS[] = {0x10,0x05,0x54};	// Steckdose a aus
char B_EIN[] = {0x10,0x11,0x51};	// Steckdose b ein
char B_AUS[] = {0x10,0x11,0x54};	// Steckdose b aus
char C_EIN[] = {0x10,0x14,0x51};
char C_AUS[] = {0x10,0x14,0x54};
char D_EIN[] = {0x10,0x15,0x11};
char D_AUS[] = {0x10,0x15,0x14};
char E_EIN[] = {0x10,0x15,0x41};
char E_AUS[] = {0x10,0x15,0x44};

	char i, unveraendert;
	unsigned int tcpdata;
	unveraendert = 0xff;
	
	// Startpunkt der Daten im Tcp buffer errechnen (IP Headerlnge + TCP Headerlnge + Ethernetframe)
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	// Verwaltung des TCP/IP-Stackpointers

	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack (buffer,bufferlen,&a)==1)	return;	//keine Daten fr Anwendung

	tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
	
	// HTTP Header berprfen
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN1) {
		
		// Get-Daten auswerten 	
		pointerold = Page0;				// Pointerold auf Fehlerseite setzen
		
		unsigned char File_Name[13];	//File_Name entspricht 8.3 & Endmakierung
		
		//berprft Header nach "GET /File_Name HTTP....."
		if (strncmp_P(&buffer[tcpdata],PSTR("GET /"),5) == 0) 
		{
			char *tmppointer = &buffer[tcpdata + 5];
			unsigned char counter = 0;
			//Der Header wird durchsucht beginnend bei "GET /" bis zum nchsten Space oder "?"
			while ((* tmppointer != 0x20) & (* tmppointer != '?') & (counter<12))
			{
				File_Name[counter] = *tmppointer++;
				counter++;
			}
			File_Name[counter] = '\0';			//Endmarkierung setzen
			
			if (File_Name[0] == '\0') 		//Enthlt der Header keinen File Namen wird dieser Index.htm
				memcpy(File_Name,"index.htm\0",10);
				
			printf(File_Name);
			printf("\n");
			
#if USE_MMC
			//Root Verzeichnis nach File Namen durchsuchen
			unsigned char Dir_Attrib;
			
			//Lade Cluster fr das File welches in File_Name steht 
			tcp_socket->Cluster = 0; //suche im Root Directory
			if (Search_File(File_Name, 
					&tcp_socket->Cluster, 
					&tcp_socket->File_Size,
					&Dir_Attrib, 
					&buffer[tcpdata]) == 1)
				tcp_socket->File_Block_Counter = 0;
			else
				tcp_socket->Cluster = 0;
				//wurde das File nicht gefunden, wird eine Seite aus Flashspeicher angezeigt
#endif //USE_MMC
			
		}	// Ende if "GET /"


#if USE_MCA25_CAM
		if (strncmp_P(File_Name,PSTR("cam.jpg"),7) == 0){		//cam picture requestet
			if (mca25_cam_busy_for_socket == MCA25_NOT_BUSY){ 		//new image -> status = 0
				mca25_configure();	// falls die Parameter gendert wurden ist neu zu konfigurieren
				mca25_cam_status = MCA25_FIRST_DATA;				//cam is reserved fr socket a
				mca25_cam_busy_for_socket = a;
			}else	if (mca25_cam_busy_for_socket == a){			//ooooops, cam pic tranfer has been canceled
				mca25_cam_status = MCA25_SKIP_PICTURE;				//we need to reset the camera...
				mca25_cam_busy_for_socket = a;
			}else if (mca25_cam_busy_for_socket==MCA25_STILL_BUSY){	//same as above but there was another request
				mca25_cam_status = MCA25_SKIP_PICTURE;				//before -> skip picture now
				mca25_cam_busy_for_socket = a;
			}else	pointerold = Picture1;				//cam is busy -> show busy jpg
		}
		else				//cam picture _NOT_ requested !
			if (mca25_cam_busy_for_socket == a){			//if there was an picture request before
				mca25_cam_status = MCA25_SKIP_PICTURE;		//which was interrupted, we need to skip the picture later
				mca25_cam_busy_for_socket = MCA25_STILL_BUSY;
			}
#endif 

#if USE_SERVO
		if (strncmp_P(File_Name,PSTR("cam?v="),6) == 0){
			unsigned char val = (unsigned char)atoi(File_Name+6);
			servo_prepare_pos(val);
		}
#endif

		if (strncmp_P(File_Name,PSTR("index.htm"),   9) == 0) pointerold = Page1;
		if (strncmp_P(File_Name,PSTR("temp.htm"),    8) == 0) pointerold = Page2;
		if (strncmp_P(File_Name,PSTR("dump.htm"),    8) == 0) pointerold = Page3;
		if (strncmp_P(File_Name,PSTR("einst.htm"),   9) == 0) pointerold = Page4;
		if (strncmp_P(File_Name,PSTR("name.htm"),    8) == 0) pointerold = Page5;
		if (strncmp_P(File_Name,PSTR("log.htm"),     7) == 0) pointerold = Page6;
#if USE_MCA25_CAM
		if (strncmp_P(File_Name,PSTR("cam.htm"),     7) == 0) pointerold = Page7;
#endif
		if (strncmp_P(File_Name,PSTR("tg.jpg"),      6) == 0) pointerold = Picture1;
		if (strncmp_P(File_Name,PSTR("favicon.ico"),11) == 0) pointerold = Picture2;
		
		// Abfragen, ob Parameter zurckgegeben wurden
		// gfs. die Variablen entsprechend setzen
		//
		hh =searchParameter("VAh",buffer+tcpdata,*bufferlen-tcpdata,hh); 
		mm =searchParameter("VAm",buffer+tcpdata,*bufferlen-tcpdata,mm); 
		ss =searchParameter("VAs",buffer+tcpdata,*bufferlen-tcpdata,ss); 
		
		VA2=searchParameter("VA2",buffer+tcpdata,*bufferlen-tcpdata,VA2); 
		OCR2 = VA2; // LED im PWM-Betrieb einstellen 
		
		VA3=searchParameter("VA3",buffer+tcpdata,*bufferlen-tcpdata,VA3);
		
		VA4=searchParameter("VA0",buffer+tcpdata,*bufferlen-tcpdata,VA4);	// Checkbox lschen
		VA4=searchParameter("VA4",buffer+tcpdata,*bufferlen-tcpdata,VA4); 
		VA5=searchParameter("VA0",buffer+tcpdata,*bufferlen-tcpdata,VA5); // Checkbox lschen
		VA5=searchParameter("VA5",buffer+tcpdata,*bufferlen-tcpdata,VA5); 
		VA6=searchParameter("VA0",buffer+tcpdata,*bufferlen-tcpdata,VA6);	// Checkbox lschen 
		VA6=searchParameter("VA6",buffer+tcpdata,*bufferlen-tcpdata,VA6); 
		
	//	VAX=searchParameter("VA9",buffer+tcpdata,*bufferlen-tcpdata,VAX);	// Checkbox lschen 
	//	VAX=searchParameter("VAX",buffer+tcpdata,*bufferlen-tcpdata,VAX); 
	//	if (VAX) PORTB |= (1<<4); // Port B 4 einschalten
	//	    else PORTB &= ~(1<<4); // Port B 4 ausschalten
		VAY=searchParameter("VA9",buffer+tcpdata,*bufferlen-tcpdata,VAY);	// Checkbox lschen 
		VAY=searchParameter("VAY",buffer+tcpdata,*bufferlen-tcpdata,VAY); 
		if (VAY) PORTA |= (1<<5); // Port A 5 einschalten
		    else PORTA &= ~(1<<5); // Port A 5 ausschalten
		VAZ=searchParameter("VA9",buffer+tcpdata,*bufferlen-tcpdata,VAZ);	// Checkbox lschen 
		VAZ=searchParameter("VAZ",buffer+tcpdata,*bufferlen-tcpdata,VAZ); 
		if (VAZ) PORTA |= (1<<6); // Port A 6 einschalten
		    else PORTA &= ~(1<<6); // Port A 6 ausschalten
		VAhA=searchParameter("VA9",buffer+tcpdata,*bufferlen-tcpdata,VAhA);	// Checkbox lschen 
		VAhA=searchParameter("VAhA",buffer+tcpdata,*bufferlen-tcpdata,VAhA); 	
		if (VAhA){ sendeTelegramm(A_EIN);VAhA =1;} // Funkport a einschalten
		    else{ sendeTelegramm(A_AUS);VAhA =0;} // Funkport A ausschalten
		VAhB=searchParameter("VA9",buffer+tcpdata,*bufferlen-tcpdata,VAhB);	// Checkbox lschen 
		VAhB=searchParameter("VAhB",buffer+tcpdata,*bufferlen-tcpdata,VAhB); 		
		if (VAhB){ sendeTelegramm(B_EIN);VAhB =1;} // Funkport b einschalten
		    else{ sendeTelegramm(B_AUS);VAhB =0;} // Funkport b ausschalten
		VAhC=searchParameter("VA9",buffer+tcpdata,*bufferlen-tcpdata,VAhC);	// Checkbox lschen 
		VAhC=searchParameter("VAhC",buffer+tcpdata,*bufferlen-tcpdata,VAhC); 		
		if (VAhC){ sendeTelegramm(C_EIN);VAhC =1;} // Funkport C einschalten
		    else{ sendeTelegramm(C_AUS);VAhC =0;} // Funkport C ausschalten
		VAhD=searchParameter("VA9",buffer+tcpdata,*bufferlen-tcpdata,VAhD);	// Checkbox lschen 
		VAhD=searchParameter("VAhD",buffer+tcpdata,*bufferlen-tcpdata,VAhD); 		
		if (VAhD){ sendeTelegramm(D_EIN);VAhD =1;} // Funkport D einschalten
		    else{ sendeTelegramm(D_AUS);VAhD =0;} // Funkport D ausschalten
		VAhE=searchParameter("VA9",buffer+tcpdata,*bufferlen-tcpdata,VAhE);	// Checkbox lschen 
		VAhE=searchParameter("VAhE",buffer+tcpdata,*bufferlen-tcpdata,VAhE); 		
		if (VAhE){ sendeTelegramm(E_EIN);VAhE =1;} // Funkport E einschalten
		    else {sendeTelegramm(E_AUS);VAhE =0;} // Funkport E ausschalten
		
		unveraendert=searchParameter
		("VA0",buffer+tcpdata,*bufferlen-tcpdata,unveraendert);	// EEPROM Checksumme erneuern 
		
		VAi=searchParameter("VAi",buffer+tcpdata,*bufferlen-tcpdata,VAi); 
		VAj=searchParameter("VAj",buffer+tcpdata,*bufferlen-tcpdata,VAj); 
		VAk=searchParameter("VAk",buffer+tcpdata,*bufferlen-tcpdata,VAk); 
		VAl=searchParameter("VAl",buffer+tcpdata,*bufferlen-tcpdata,VAl);
		VAB=searchParameter("VAB",buffer+tcpdata,*bufferlen-tcpdata,VAB);	// Art des Speicherdumps
		
#if USE_MCA25_CAM
		VAF=searchParameter("VAF",buffer+tcpdata,*bufferlen-tcpdata,VAF); // Funlayer
		if (VAF>8) VAF=0; // zulssigen Bereich einschrnken
		VAP=searchParameter("VAP",buffer+tcpdata,*bufferlen-tcpdata,VAP);	// Bildformat
#endif
 		VAR=searchParameter("VAR",buffer+tcpdata,*bufferlen-tcpdata,VAR); 
		Index=searchParameter("VAL",buffer+tcpdata,*bufferlen-tcpdata,Index); 
		
		VAS=searchParameter("VAS",buffer+tcpdata,*bufferlen-tcpdata,VAS); // Schaltschwelle
		
		searchName("VAN",buffer+tcpdata,*bufferlen-tcpdata); 
		
		VA0=searchParameter("VAE",buffer+tcpdata,*bufferlen-tcpdata,0xff); 
		if ((VA0 < MAX_DEVICES)	// Nummer im zulssigen Bereich ?
			&& (VA0 == Index)		// und identisch mit dem Index ?
			&& (VA0!=0xff)) {		// und korrekt gesetzt ?
			for (i=0;i<16;i++)	// Alle 16 Bytes des Datensatzes 
			  eeprom_write_byte((uint8_t *)(VA0<<4)+i,0xff);// mit "ff" berschreiben
			DALLAS[VA0][0]=0x7f;	// Marke "Eintrag ist leer" setzen
			DALLAS[VA0][1]=0xff;	// Eintrag auf "kein Thermometer" setzen
		}
		
		// Wenn Aktionen erforderlich sind, werden diese hier durchgefhrt
		//
		if (VA4) DALLAS[0][0] |= OWI_PIN_4; else DALLAS[0][0] &= (~OWI_PIN_4);
		if (VA5) DALLAS[0][0] |= OWI_PIN_5; else DALLAS[0][0] &= (~OWI_PIN_5);
		if (VA6) DALLAS[0][0] |= OWI_PIN_3; else DALLAS[0][0] &= (~OWI_PIN_3);
		
		if (!unveraendert) {	// Wenn Dallas-Optionen gendert wurden, EEPROM aktualisieren
			eeprom_write_byte((char *)(char)4+IPoffset,VA3);				// VA3 ins EEPROM schreiben
			eeprom_write_byte((char *)(char)5+IPoffset,DALLAS[0][0]);	// DALLAS[0][0] ins EEPROM schreiben
			eeprom_write_byte((char *)(char)6+IPoffset,VAR);				// VAR ins EEPROM schreiben
		}
		
		if (	(VAi != eeprom_read_byte((char *)(char)0+IPoffset)) 
			||	(VAj != eeprom_read_byte((char *)(char)1+IPoffset)) 
			||	(VAk != eeprom_read_byte((char *)(char)2+IPoffset))
			||	(VAl != eeprom_read_byte((char *)(char)3+IPoffset)) ) { // Wenn die IP-Adresse verndert wurde
			eeprom_write_byte((char *)(char)0+IPoffset,VAi);			// Neue IP-Adresse ins EEPROM schreiben
			eeprom_write_byte((char *)(char)1+IPoffset,VAj);
			eeprom_write_byte((char *)(char)2+IPoffset,VAk);
			eeprom_write_byte((char *)(char)3+IPoffset,VAl);
			unveraendert = 0;		// nderung des EEPROM-Bereiches
		}
		
		if (!unveraendert) {	// Wenn das EEPROM gendert wurde, neue Prfsumme ermitteln
			unsigned char CRC=0;
			for (i=0; i<7; i++) 
				CRC=OWI_ComputeCRC8(eeprom_read_byte((char *)(char)IPoffset+i),CRC);	// CRC ermitteln
			eeprom_write_byte((char *)(char)7+IPoffset,CRC);				// und ins EEPROM schreiben
		}
				
		tcp_store(buffer);								//speichert Sequenzcounter und Acknowledgecounter
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;	//setzen des Ack Flags und PSH Flags
		
		
		// tcp_add_data (HTTP_OK1,buffer,bufferlen);		// HTTP OK Paket erzeugen 
		if (strstr(File_Name,".ico")) 
			tcp_add_data (HTTP_ico,buffer,bufferlen);
		else 
			if (strstr(File_Name,".jpg")) 
				tcp_add_data (HTTP_jpg,buffer,bufferlen);
			else  
				tcp_add_data (HTTP_html,buffer,bufferlen);
		
		tcp_make(buffer);								//erzeugt ein TCP Packet 
		Write_Ethernet_Frame (buffer,*bufferlen);		//sendet das erzeugte TCP Packet 
		
		//(Ethernet Frame war voll) weiterer Frame mu gesendet werden!
		tcp_socket->Status = TCP_SOCKET_OPEN2;
		tcp_socket->Pointer = pointerold;
		return;
	}
	
	//Senden der Webseite bzw. Daten war noch nicht Fertig (Ethernet Frame war aber voll)	
	if (tcp_socket->Status == TCP_SOCKET_OPEN2) 
	{
		unsigned char Buffer_Full = 0;
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;	//Setzen des Ack Flags und PSH Flags	
		tcp_store(buffer);								//Speichert Sequenzcounter und Aknowledgecounter
		//erzeugt Seiten Packet
		
#if USE_MMC
		if(tcp_socket->Cluster != 0)
		{
			Read_File (tcp_socket->Cluster,&buffer[tcpdata],tcp_socket->File_Block_Counter);
			tcp_socket->File_Block_Counter++;
			if (tcp_socket->File_Size > (unsigned long)512)
			{
				Buffer_Full = 1; //es wurden noch nicht alle Daten gesendet
				(unsigned long) tcp_socket->File_Size = (unsigned long) tcp_socket->File_Size - 512;
				TCP_New_Packtlen (buffer,bufferlen,tcpdata + 512);
			}
			else
			{
				Buffer_Full = 0; //es wurden alle Daten gesendet
				TCP_New_Packtlen (buffer,bufferlen,tcpdata + tcp_socket->File_Size);
			}
			goto endmakepacket;
		}
#endif //USE_MMC

#if USE_MCA25_CAM
		if ( mca25_cam_busy_for_socket == a ){
			if (mca25_copy_image_data_to_tcp_buffer(buffer, bufferlen) == 1){
				Buffer_Full = 1;	//more packets:
			}else{
				Buffer_Full = 0;	//last packet
				mca25_cam_busy_for_socket = MCA25_NOT_BUSY;
			}
			goto endmakepacket;
		}
#endif

		pointerold = tcp_socket->Pointer;
		Buffer_Full = tcp_add_data (pointerold,buffer,bufferlen);
		tcp_socket->Pointer = pointerold;
	
#if USE_MCA25_CAM
		endmakepacket:
#endif
	
		tcp_make(buffer);							//Erzeugt ein TCP Packet
		Write_Ethernet_Frame (buffer,*bufferlen);	//Sendet das erzeugte TCP Packet 
		if (Buffer_Full == 0) {
#if USE_MMC
			tcp_socket->Cluster = 0;
#endif
			tcp_socket->Status = TCP_SOCKET_CLOSE;
		}
		return;		
	}
return;
}


