/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "rtl8019.h"

//Routinen zum Ansteuern der Netzwerkkarte 

//############################################################################
// Schreibt ein Byte in das angegebene Register der Netzwerkkarte
void WriteRTL (unsigned char rtl_addr,unsigned char rtl_data)
//############################################################################
{
	DATA_CTRL_RLT = OUTPUT;			//Der Datenport wird auf output gesetzt vom C zum NIC schreiben
//	ADDR_PORT_RLT = rtl_addr;		//write Adress to Port - so nicht, wir haben den Controller nicht fr uns allein!
	ADDR_PORT_RLT = ((ADDR_PORT_RLT & ~ADDR_OUTPUT) | rtl_addr);	// write Address to Port
	DATA_PORT_RLT_WRITE = rtl_data;	//write Data to Port
	RTL_WR_OFF();					//set write Pin to Low
        nop();						//wait a short time
        nop(); 						//gib mal ein bichen GAS Ulrich ;)
	RTL_WR_ON();					//set write Pin to High
}									//write to RTL complete

//############################################################################
// Auslesen eines Bytes aus dem angegebenen Register der Netzwerkkarte
unsigned char ReadRTL (unsigned char rtl_addr)
//############################################################################
{
	unsigned char rtl_data;
	DATA_CTRL_RLT = INPUT;			//Der Datenport wird auf input gesetzt vom NIC zum C lesen
	ADDR_PORT_RLT = ((ADDR_PORT_RLT & ~ADDR_OUTPUT) | rtl_addr);	// write Address to Port
	RTL_RD_OFF();					//set read Pin to Low
	nop();	nop();					//wait a short time	
	rtl_data = DATA_PORT_RLT_READ;	//read from port rtldata
	RTL_RD_ON();					//set Read Pin to High
	return (rtl_data);				//read from RTL complete
}

//############################################################################
//Hier wird die Netzwerkkarte initialisiert
void Network_init (void)
//############################################################################
{
	// 
	// Vorbereitende Manahmen am Prozessor
	//
	
	#if defined (__AVR_ATmega128__)
		DATA_ADDR_RLT = OUTPUT;		//Set Addr Port Direction = Output
	#endif

	#if defined (__AVR_ATmega32__)
	//	DATA_ADDR_RLT = OUTPUT;		//Set Addr Port Direction = Output
		DATA_ADDR_RLT |= ADDR_OUTPUT;		//Set Address Port Direction = Output
	#endif

    #ifndef ISP_CTRL
		ADDR_PORT_RLT = OUTPUT;		//Set all Addrport High
	#else
		// fr ISP-CTRL  
		ADDR_PORT_RLT |= ADDR_OUTPUT;	// nur die 5 Adressleitungen
		CTRL_LINES_DIR |=  (1<<READ_PIN);
		CTRL_LINES_DIR |= (1<<RESET_PIN);
		CTRL_LINES_DIR |= (1<<WRITE_PIN);
	#endif	
	
	DATA_CTRL_RLT = INPUT;			//set Data Port Direction = Input

	//
	// Programmiereung des RTL8019AS
	//
	
	RTL_RESET_OFF();	//Set Reset Pin Low

	//added by holgi
	//meine Karten laufen nur wenn man hier noch ca. 100ms wartet
	// unsigned long i = 0;
	// while (i < 60000 * 5) i++;
	_delay_ms(100);
	//end added by holgi
	
	ReadRTL (RSTPORT);
	WriteRTL (RSTPORT, 0xFF);
	
	_delay_ms(1);
	
//***********************************************************************************************
// Einschub von jb 26.06.2005
// Auslesen des EEPROMs 93LC46 auf der Netzwerkkarte und Ausgabe des Speicherdumps
//
	WriteRTL (CR, (1<<STP| 1<<RD2 |PAGE3));		// Page 3 ansteuern
	WriteRTL (CR9346,(EEM1));						// 9346 programming mode
	WriteRTL (CR9346,(EEM1 |EECS |EEDI));			// CS und DI setzen
	WriteRTL (CR9346,(EEM1 |EECS |EEDI |EESK));	// Startbedingung = steigende Taktflanke
	WriteRTL (CR9346,(EEM1 |EECS |EEDI));			// Takt = 0	
	WriteRTL (CR9346,(EEM1 |EECS |EEDI |EESK));	// Takt = 1	erstes Opcode-Bit = 1	
	WriteRTL (CR9346,(EEM1 |EECS ));				// Takt = 0	
	WriteRTL (CR9346,(EEM1 |EECS |EESK));			// Takt = 1	zweites Opcode-Bit = 0
		
	unsigned char j;
	for (j=1; j<=6; j++) { // IM EEPROM sechs Adressbits setzen (wir sind im 16-bit-Modus!)
		WriteRTL (CR9346,(EEM1 |EECS ));			// Takt = 0	
		WriteRTL (CR9346,(EEM1 |EECS |EESK));		// Takt = 1	Bit=0 einschieben
	}
		
	printf_P (PSTR("\r\n93LC46 Dump:\r\n"));		// berschrift ausgeben
	dump (128,*read9346);							// 93LC46-Speicherdump mit 128 Byte ausgeben
		
	WriteRTL (CR9346,(0));							// NIC zurck in die normale Betriebsart
//
// Ende des Einschubs
//***********************************************************************************************

	WriteRTL (CR , (1<<STP| 1<<RD2));			// Stop, RD2 -> Abort/Complete remote DMA

	_delay_ms(1);

	WriteRTL (DCR , DCRVAL);					// Data Configuration Register 0x58, 
	// FIFO threshold select, Send Packet Command executed
	WriteRTL (RBCR0 , 0x00);					// Remote Byte Count Register
	WriteRTL (RBCR1 , 0x00);
	WriteRTL (RCR , 0x04);						// Receive Configuration Register, 
	// Packets with broadcast dest. accepted
	WriteRTL (TPSR , RXSTART);					// Transmit Page Start Register 0x46
	WriteRTL (TCR , 0x02);						// Transmit Configuration Register, 
	// CRC Generator enabled, CRC Checker disabled
	WriteRTL (PSTART , RXSTART);				// page start address of the receive buffer ring 0x46
	WriteRTL (BNRY , RXSTART);					// Boundary Register
	WriteRTL (PSTOP , RXSTOP);					// stop page address of the receive buffer ring 0x60
	WriteRTL (CR ,(1<<STP| 1<<RD2|1<<PS0)); 	// Stop, Pageumschaltung

	_delay_ms(1);

	WriteRTL (CURR , RXSTART);					// Current Page Register -> first receive buffer page 0x46
	
	for(int a = 0; a<=5; a++)
		WriteRTL ((PAR0 + a) , mymac[a]);		// Physical Address Register

	WriteRTL (CR , (1<<STP| 1<<RD2));			// Stop, Pageumschaltung
	WriteRTL (DCR , DCRVAL);					// Data Configuration Register 0x58, 
	// FIFO threshold select, Send Packet Command executed
	WriteRTL (CR , (1<<STA| 1<<RD2));			// Start: RD2 -> Abort/Complete remote DMA
	WriteRTL (ISR ,(1<<PRX|1<<PTX|1<<RXE|1<<TXE|1<<OVW|1<<CNT|1<<RDC|1<<RST)); // Clear Interrupt Status Register
	WriteRTL (IMR , IMRVAL);					// Interrupt Mask Register 0x11,
	// Enable packet received with no errors, receive buffer exhausted
	WriteRTL (TCR , TCRVAL);					// Transmit Configuration Register 0x00, normal operation
	
	WriteRTL (CR ,(1<<STA| 1<<RD2));			// Start: RD2 -> Abort/Complete remote DMA (Netzwerkkarte starten)
	
    DATA_PORT_RLT_WRITE = 255;					// Schreibt eine 255 auf den BUS
}

//############################################################################
void Write_Ethernet_Frame (char *buffer,unsigned int bufferlen)
//############################################################################
{
	unsigned int a;

	// Buffer auf eine min. Lnge von 60 Bytes berprfen, wenn kleiner dann auffllen
	if (bufferlen < 0x40) {
		for (a = (bufferlen-4);a <= 0x44;a++)	buffer[a] = 0x20;
		bufferlen = 0x40;
	}
		
	WriteRTL (CR,(1<<STA| 1<<RD2));			// Start: RD2 -> Abort/Complete remote DMA
	WriteRTL (TPSR,TXSTART);					// Transmit Page Start Register 0x40
	WriteRTL (RSAR0,0x00);						// Remote Start Address Register
	WriteRTL (RSAR1,0x40);
	WriteRTL (ISR,(1<<PRX|1<<PTX|1<<RXE|1<<TXE|1<<OVW|1<<CNT|1<<RDC|1<<RST)); // Clear Interrupt Status Register
	WriteRTL (RBCR0,(bufferlen & 0x00ff) - 4);// Remote Byte Count Register
	WriteRTL (RBCR1,(bufferlen & 0xff00) >>8);
	WriteRTL (CR,(1<<STA| 1<<RD1));			// Start: Remote Write

//07.10.2004 Holger Klabunde
//WriteRTL(x) in der Schleife quasi durch den INHALT von WriteRTL(x) ersetzt
// 
//DATA_CTRL_RLT = OUTPUT; und ADDR_PORT_RLT = (96 + RDMAPORT);
//aus der Schleife rausgenommen und darber gesetzt. 
//Beide Befehle wurden unntigerweise mehrfach ausgefhrt.
//Da man in der Schleife jetzt auch keine Funktion WriteRTL(x) mit Parameterbergabe
//mehr aufruft wird eine Menge Rechenzeit gespart.

	DATA_CTRL_RLT = OUTPUT;			// Der Datenport wird auf output gesetzt; vom C zum NIC schreiben
	ADDR_PORT_RLT = ((ADDR_PORT_RLT & ~ADDR_OUTPUT) | (RDMAPORT));	// write Address to Port

	for (a = 0; a < (bufferlen - 4);a++)
	{
		DATA_PORT_RLT_WRITE = buffer[a];	//write Data to Port
		RTL_WR_OFF();						//set write Pin to Low
	     	nop();		//wait a short time
        	nop(); 		//gib mal ein bichen GAS Ulrich ;) Holgi
		RTL_WR_ON();	//set write Pin to High, write to RTL complete
	}

	Check_Clock ();	// Nach jedem gesendeten Paket die Uhr prfen

	while ((ReadRTL(ISR)&(1<<RDC)) == 0) {}		// loop_until_bit_is_set(ReadRTL(isr),rdc);
	// Set when remote DMA operation has been completed

	WriteRTL (TBCR0,(bufferlen & 0x00ff) - 4);	// Transmit Byte Count Register
	WriteRTL (TBCR1,(bufferlen & 0xff00) >>8);
	WriteRTL (CR,(1<<TXP| 1<<RD2));				// TXP must be set to transmit a Packet.
	// RD2 -> Abort/Complete remote DMA
}

//############################################################################
void Read_Ethernet_Frame (char *buffer,unsigned int *bufferlen)
//############################################################################
{
	unsigned int tmp1,tmp2;
	unsigned int a;
	unsigned char by = 0;

	WriteRTL(CR ,(1<<STA| 1<<RD0| 1<<RD1));		// Send Packet
	ReadRTL(RDMAPORT);								// Remote DMA Port
	ReadRTL(RDMAPORT);
	tmp1 = ReadRTL(RDMAPORT);
	*bufferlen = (ReadRTL(RDMAPORT)<<8)+tmp1;

//07.10.2004 Holger Klabunde
//ReadRTL(x) in der Schleife quasi durch den INHALT von ReadRTL(x) ersetzt
// 
//DATA_CTRL_RLT = INTPUT; und ADDR_PORT_RLT = (96 + RDMAPORT);
//aus der Schleife rausgenommen und darber gesetzt. 
//Beide Befehle wurden unntigerweise mehrfach ausgefhrt.
//Da man in der Schleife jetzt auch keine Funktion ReadRTL(x) mit Parameterbergabe
//mehr aufruft wird eine Menge Rechenzeit gespart.

	DATA_CTRL_RLT = INPUT;			// Der Datenport wird auf input gesetzt, vom NIC zum C lesen
	ADDR_PORT_RLT = (ADDR_PORT_RLT & ~ADDR_OUTPUT) | (RDMAPORT);	// write Address to Port

//14.10.2004 Holger Klabunde
//RAM Zugriffe ber die Gre des Buffers hinaus verhindern
//Die Abfrage dazu stand vorher in der Byteleseschleife.
//Das dauerte aber viel zu lange.
//Jetzt sind es zwei Schleifen. Bringt nochmal ca. 10%.

	tmp1=*bufferlen; //Annehmen *bufferlen passt in den Buffer
	tmp2=0;          //Rest ist erstmal 0

	if(*bufferlen>(MTU_SIZE-1)){	//Mehr Daten vorhanden als in den Buffer passen
		tmp1=(MTU_SIZE-1);					//Daten nur bis MTU_SIZE-1 in den Buffer bernehmen
		tmp2=*bufferlen-tmp1;				//den Rest abholen, aber ignorieren !
	} 

	for(a=0; a<tmp1; a++){		//Daten in den Buffer bernehmen solange sie reinpassen
		RTL_RD_OFF();						//set read Pin to Low
		nop();	nop();						//wait a short time
		buffer[a] = DATA_PORT_RLT_READ;	//read from port rtldata
		RTL_RD_ON();						//set Read Pin to High
	}//read from RTL complete

	for(a=0; a<tmp2; a++)	{		//Daten abholen die NICHT mehr in den Buffer passen
	// Anmerkung holgi: Kommt das berhaupt einmal vor ? 
	// jb: Es knnte sein, da ein zu groes Paket eintrifft
		RTL_RD_OFF();						//set read Pin to Low
		nop();	nop();						//wait a short time
		by = DATA_PORT_RLT_READ;			//read from port rtldata to Dummy
		RTL_RD_ON();		   				//set Read Pin to High
	}//read from RTL complete
	
	buffer[tmp1 + 1] = 0;	

	by = by & RDC;		// & Bit 6
	if ( by != 64 )	ReadRTL(ISR);
}
